----------------------------------------------------------------------------------
-- Engineers: 			Derek Nguyen and Ryan Frawley
-- Create Date:    	03:53:48 12/03/2014 
-- Module Name:    	End_Tie
-- Project Name: 	 	TicTacToe_V2
-- Target Devices: 	Nexys FPGA
-- Description:    	This will take care of the state where all of the button are 
--							pressed but the game ended in a Tie
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity End_Tie is
	port (Button		: in std_logic_vector(8 downto 0);
			Reset			: in std_logic;
			clock			: in std_logic;
			Judgement	: out std_logic);
end End_Tie;

architecture Behavioral of End_Tie is

component D_FlipFlop is
	port (Enable: in std_logic;
			D 		: in std_logic;
			Reset	: in std_logic;
			Clock	: in std_logic;
			Q 		: out std_logic);
end component;

signal btn0, btn1, btn2, btn3, btn4, btn5, btn6, btn7, btn8 : std_logic;

begin

	D_FF0 : D_FlipFlop port map(Button(0), '1', Reset, Clock, btn0);
	D_FF1 : D_FlipFlop port map(Button(1), '1', Reset, Clock, btn1);
	D_FF2 : D_FlipFlop port map(Button(2), '1', Reset, Clock, btn2);
	D_FF3 : D_FlipFlop port map(Button(3), '1', Reset, Clock, btn3);
	D_FF4 : D_FlipFlop port map(Button(4), '1', Reset, Clock, btn4);
	D_FF5 : D_FlipFlop port map(Button(5), '1', Reset, Clock, btn5);
	D_FF6 : D_FlipFlop port map(Button(6), '1', Reset, Clock, btn6);
	D_FF7 : D_FlipFlop port map(Button(7), '1', Reset, Clock, btn7);
	D_FF8 : D_FlipFlop port map(Button(8), '1', Reset, Clock, btn8);
	
	Judgement <= btn0 and btn1 and btn2 and btn3 and btn4 and btn5 and btn6 and btn7 and btn8;
	
end Behavioral;

