------------------------------------------------------------------------------------
-- Engineers: 			Derek Nguyen and Ryan Frawley
-- Create Date:    	03:53:48 12/03/2014 
-- Module Name:    	Multi_LED_Handle
-- Project Name: 	 	TicTacToe_V2
-- Target Devices: 	Nexys FPGA
-- Description:    	Handling Dataflow of Multiple LED
--							We will be using XOR Gate to determine which player turn is it
------------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Multi_LED_Handle is
	port (Reset		: in std_logic;
			Input1 	: in std_logic_vector(1 downto 0);
			Input2 	: in std_logic_vector(1 downto 0);
			Input3 	: in std_logic_vector(1 downto 0);
			Input4 	: in std_logic_vector(1 downto 0);
			Input5 	: in std_logic_vector(1 downto 0);
			Input6 	: in std_logic_vector(1 downto 0);
			Input7 	: in std_logic_vector(1 downto 0);
			Input8 	: in std_logic_vector(1 downto 0);
			Input9 	: in std_logic_vector(1 downto 0);
			Output 	: out std_logic_vector(1 downto 0));
end Multi_LED_Handle;

architecture Dataflow of Multi_LED_Handle is

signal temp : std_logic_vector(9 downto 0);


begin
	
	-- XOR First level
	temp(0) <= input1(0) XOR input1(1);
	temp(1) <= input2(0) XOR input2(1);
	temp(2) <= input3(0) XOR input3(1);
	temp(3) <= input4(0) XOR input4(1);
	temp(4) <= input5(0) XOR input5(1);
	temp(5) <= input6(0) XOR input6(1);
	temp(6) <= input7(0) XOR input7(1);
	temp(7) <= input8(0) XOR input8(1);
	temp(8) <= input9(0) XOR input9(1);
	
	-- XOR Second level
	temp(9) <= temp(0) XOR temp(1) XOR temp(2) XOR temp(3) XOR temp(4) XOR temp(5) XOR temp(6) XOR temp(7) XOR temp(8);
	
	
	Output(0) <= temp(9);
	Output(1) <= not(temp(9));
		

	
end Dataflow;

