----------------------------------------------------------------------------------
-- Engineers: 			Derek Nguyen and Ryan Frawley
-- Create Date:    	03:53:48 12/03/2014 
-- Module Name:    	Single_LED_Controller
-- Project Name: 	 	TicTacToe_V2
-- Target Devices: 	Nexys FPGA
-- Description:    	Control the behavior of a single LED
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Single_LED_Controller is
	port (Clock		: in std_logic;
			Button	: in std_logic;
			Reset		: in std_logic;
			Player1	: in std_logic;
			Player2	: in std_logic;
			LED_Output	: out std_logic_vector(1 downto 0);
			Handle_Input : out std_logic_vector(1 downto 0));			
end Single_LED_Controller;

architecture Behavioral of Single_LED_Controller is

component D_FlipFlop is
	port (Enable: in std_logic;
			D 		: in std_logic;
			Reset	: in std_logic;
			Clock	: in std_logic;
			Q 		: out std_logic);
end component;

signal temp1, temp2 : std_logic;

begin
	
	D_FF_Main_1 : D_FlipFlop port map(Button, Player1, Reset, Clock, temp1);
	D_FF_Main_2 : D_FlipFlop port map(Button, Player2, Reset, Clock, temp2);
	
	LED_Output(0) <= not(temp1);
	LED_Output(1) <= not(temp2);

	Handle_Input(0) <= temp1;
	Handle_Input(1) <= temp2;
	
end Behavioral;

