----------------------------------------------------------------------------------
-- Engineers: 			Derek Nguyen and Ryan Frawley
-- Create Date:    	03:53:48 12/03/2014 
-- Module Name:    	T_FF_Counter
-- Project Name: 	 	TicTacToe_V2
-- Target Devices: 	Nexys FPGA
-- Description:    	2-Bits Counter
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity T_FF_Counter is
	port (Clock		: in std_logic;
			Btn		: in std_logic;
			Output	: out std_logic_vector(1 downto 0));
end T_FF_Counter;

architecture Behavioral of T_FF_Counter is

component T_FlipFlop is
	port (T		: in std_logic;
			Enable: in std_logic;
			Clock : in std_logic;
			Q		: out std_logic);
end component;

signal temp : std_logic_vector(1 downto 0);

begin
	
	T_FF0 : T_FlipFlop port map('1', Btn, Clock, temp(0));
	T_FF1 : T_FlipFlop port map(temp(0), Btn, Clock, temp(1));
	
	Output <= temp;

end Behavioral;

