----------------------------------------------------------------------------------
-- Engineers: 			Derek Nguyen and Ryan Frawley
-- Create Date:    	03:53:48 12/03/2014 
-- Module Name:    	T_FlipFlop
-- Project Name: 	 	TicTacToe_V2
-- Target Devices: 	Nexys FPGA
-- Description:    	Toggle Flip FLop
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity T_FlipFlop is
	port (T		: in std_logic;
			Enable: in std_logic;
			Clock : in std_logic;
			Q		: out std_logic);
end T_FlipFlop;

architecture Behavioral of T_FlipFlop is

signal t_Q : std_logic := '0';

begin
	process(t_Q, T, Clock) is
	begin
		if (rising_edge(clock)) then
			if (T = '1' and Enable = '1') then
				t_Q <= not(t_Q);
			else
				t_Q <= t_Q;
			end if;
		end if;
		
		Q <= t_Q;
	end process;
	
end Behavioral;

