----------------------------------------------------------------------------------
-- Engineers: 			Derek Nguyen and Ryan Frawley
-- Create Date:    	03:53:48 12/03/2014 
-- Module Name:    	Victory
-- Project Name: 	 	TicTacToe_V2
-- Target Devices: 	Nexys FPGA
-- Description:    	Check victory conditions
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Victory is
    Port ( in1 : in  STD_LOGIC_VECTOR(1 downto 0);
           in2 : in  STD_LOGIC_VECTOR(1 downto 0);
           in3 : in  STD_LOGIC_VECTOR(1 downto 0);
           in4 : in  STD_LOGIC_VECTOR(1 downto 0);
           in5 : in  STD_LOGIC_VECTOR(1 downto 0);
           in6 : in  STD_LOGIC_VECTOR(1 downto 0);
           in7 : in  STD_LOGIC_VECTOR(1 downto 0);
           in8 : in  STD_LOGIC_VECTOR(1 downto 0);
           in9 : in  STD_LOGIC_VECTOR(1 downto 0);
			  Tie : out STD_LOGIC;
           P1win : out  STD_LOGIC;
           P2win : out  STD_LOGIC);
end Victory;

architecture Behavioral of Victory is
signal P1, P2 : std_logic;
signal T : std_logic;
signal in1t, in2t, in3t, in4t, in5t, in6t, in7t, in8t, in9t : std_logic_vector(1 downto 0);


begin

	in1t <= in1;
	in2t <= in2;
	in3t <= in3;
	in4t <= in4;
	in5t <= in5;
	in6t <= in6;
	in7t <= in7;
	in8t <= in8;
	in9t <= in9;
process (in1t, in2t, in3t, in4t, in5t, in6t, in7t, in8t, in9t) is
begin
	--player 1 conditions
	
	-- horizontal
	if (in1t(1) = '1' and in2t(1) = '1' and in3t(1) = '1') then
		p1 <= '1';


	
	elsif (in4t(1) = '1' and in5t(1) = '1' and in6t(1) = '1') then
		p1 <= '1';

	
	elsif (in7t(1) = '1' and in8t(1) = '1' and in9t(1) = '1') then
		p1 <= '1';

	
	-- vertical
	elsif (in1t(1) = '1' and in4t(1) = '1' and in7t(1) = '1') then
		p1 <= '1';
	
	
	elsif (in2t(1) = '1' and in5t(1) = '1' and in8t(1) = '1') then
		p1 <= '1';

	
	elsif (in3t(1) = '1' and in6t(1) = '1' and in9t(1) = '1') then
		p1 <= '1';

	
	-- diagonal
	elsif (in1t(1) = '1' and in5t(1) = '1' and in9t(1) = '1') then
		p1 <= '1';
	
	elsif (in3t(1) = '1' and in5t(1) = '1' and in7t(1) = '1') then
		p1 <= '1';
	else 
		p1 <= '0';
	end if;

	-- player 2 conditions
	
	-- horizontal
	if (in1t(0) = '1' and in2t(0) = '1' and in3t(0) = '1') then
		p2 <= '1';
	
	
	elsif (in4t(0) = '1' and in5t(0) = '1' and in6t(0) = '1') then
		p2 <= '1';
	
	
	elsif (in7t(0) = '1' and in8t(0) = '1' and in9t(0) = '1') then
		p2 <= '1';
	
	
	-- vertical
	
	elsif (in1t(0) = '1' and in4t(0) = '1' and in7t(0) = '1') then
		p2 <= '1';
	
	
	elsif (in2t(0) = '1' and in5t(0) = '1' and in8t(0) = '1') then
		p2 <= '1';
	
	
	elsif (in3t(0) = '1' and in6t(0) = '1' and in9t(0) = '1') then
		p2 <= '1';
	
	-- diagonal
	
	elsif (in1t(0) = '1' and in5t(0) = '1' and in9t(0) = '1') then
		p2 <= '1';
	
	
	elsif (in3t(0) = '1' and in5t(0) = '1' and in7t(0) = '1') then
		p2 <= '1';
	else 
		p2 <= '0';
	end if;
end process;
	
	

process (P1, P2) is
begin
	if (P1 = '0' and P2 = '0') then
		T <= '1';
	else
		T <= '0';
	end if;
end process;
	p1win <= P1;
	p2win <= p2;
   tie <= t;
end Behavioral;

